#include <stdio.h>
#include <string.h>

#define MAXSIZE     100

const char title[] = {
"batmake2 <in-file> <out-file>\n\n"
};

int main(int argc, char *argv[]) {
char first[MAXSIZE], last[MAXSIZE], cur[MAXSIZE], old[MAXSIZE], text[MAXSIZE], nexttext[MAXSIZE];
char *temp1, *temp2;
FILE *in = NULL, *out = NULL;
int count = 0;
    if(argc < 3) {
        printf(title);
        exit(0);
    }
    if(argc > 3) {
        printf(title);
        printf("Too many parameters!\n");
        exit(1);
    }
    in = fopen(argv[1], "rt");
    out = fopen(argv[2], "wt");
    if(!((int)(in) * (int)(out))) {
        if(in) fclose(in);
        if(out) fclose(out);
        perror("Error opening files!\n");
        exit(2);
    }
    temp1 = fgets(first, MAXSIZE, in);
    temp2 = fgets(last, MAXSIZE, in);
    if(!((int)(temp1) * (int)(temp2))) {
        fclose(in);
        fclose(out);
        perror("Unexpected end of file found!\n");
        exit(3);
    }
    first[strlen(first) - 1] = 0;
    last[strlen(last) - 1] = 0;
    if(!fgets(old, MAXSIZE, in)) {
        fclose(in); fclose(out); printf("Ain't nothing to read.\n");
        exit(3);
    }
    old[strlen(old) - 1] = 0;
    sscanf(old, "%s %s", text, old);
    while(fgets(cur, MAXSIZE, in)) {
        cur[strlen(cur) - 1] = 0;
        sscanf(cur, "%s %s", nexttext, cur);
        fprintf(out, "%s %s %s %s %s\n", first, old, cur, text, last);
        strcpy(old, cur);
        strcpy(text, nexttext);
        count++;
    }
    if(fclose(in) | fclose(out)) {
        perror("Error closing files!\n");
        exit(5);
    }
    printf("Finished!  %i lines written! ^_^\n\n", count);
}

